!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  scee_module_fftj テストプログラム (補間計算)
!
!履歴  2017/05/28  竹広真一
!
program scee_module_fftj_interpolate

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use scee_module_fftj
  implicit none

  !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

  !---- 変数 ----
  real(8)            :: zyx_Data(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: x=0.2, y=0.7, z=0.4
  real(8)            :: Ans

  integer            :: l=2, m=5

  !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','scee_module_fftj_interpolate_test', &
       'scee_module_fftj interpolate function test')

  !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call scee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  !------------------- Interpolate_cee ----------------------
  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * cos(PI*(zyx_Z-zmin)/(zmax-zmin))

  Ans = sin(l*pi*X) * sin(m*pi*Y) * cos(PI*(Z-zmin)/(zmax-zmin))

  call AssertEqual(&
    message='Interpolate_cee',&
    answer = Ans,                                                 &
    check = Interpolate_cee(cee_zyx(zyx_Data),x,y,z),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------------- Interpolate_see ----------------------
  zyx_Data = sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(2*PI*(zyx_Z-zmin)/(zmax-zmin))

  Ans = sin(l*pi*X) * cos(m*pi*Y) * sin(2*PI*(Z-zmin)/(zmax-zmin))

  call AssertEqual(&
    message='Interpolate_see',&
    answer = Ans,                                                 &
    check = Interpolate_see(see_zyx(zyx_Data),x,y,z),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','scee_module_fftj_interpolate_test', &
       'scee_module_fftj interpolate function test succeeded!')


end program scee_module_fftj_interpolate

